with Text_Io, Alphabetical,Console_Io;
with Ada.Characters.Handling;
use  Text_Io;
procedure Test_Alphabetical is
  
  procedure Manual_Test is
    S,T: String(1..80);
    N,M: Natural;
    Sign: String(1..3);
  begin
    
    S(1..5):="Andr";
    N:=5;
    loop
      M:=N;
      T(1..M):=S(1..N);
      New_Line;
      Console_Io.Put_Line("Enter a string for Alphabetical comparison to "&T(1..M));
      Console_Io.Get_Line(S,N);
      exit when N=0;
      if Alphabetical.Pos(T(1..M)) < Alphabetical.Pos(S(1..N)) then Sign:= " < ";
      elsif Alphabetical.Pos(T(1..M)) > Alphabetical.Pos(S(1..N)) then Sign:= " > ";
      else Sign:=" = ";
      end if;
      Console_Io.Put_Line(""""&T(1..M)&""""&Sign&""""&S(1..N)&"""");
    end loop;
  end;
  
  
  procedure Verify_Mapping is
    
    function Sort (S,T: String; N: Natural) return String is
      -- returns string S sorted according to string T;
      Rs,Rt: String(1..N);
      R2: String(1..3*N);
      Ch: Character;
      J: Integer;
      
    begin
      Rs(1):= S(1);
      Rt(1):= T(1);
      for I in 2..N loop
        J:=I;
        loop
          J:=J-1;
          exit when  J=0 or else Rt(J) <= T(I);
          Rs(J+1):=Rs(J);
          Rt(J+1):=Rt(J);
        end loop;
        Rs(J+1):=S(I);
        Rt(J+1):=T(I);
      end loop;
      
      J:=1;         -- insert '<'s where appropriate
      R2(1):=Rs(1);
      for I in 2..N loop
        if Rt(I-1)<Rt(I) then J:=J+2; R2(J-1):=' '; R2(J):='<'; end if;
        J:=J+1;
        R2(J):=Rs(I);
      end loop;
      
      return R2(1..J);
    end;
    
    S,T: String(1..255);
    Ch: Character;
    N: Integer; 
    
begin
  
  N:=0;
  for I in 1..255 loop
    Ch:=Character'Val(I);
    if Ada.Characters.Handling.Is_Letter(Ch) then N:=N+1;
    S(N):=Ch;
    end if;
  end loop;
  Put_Line("The Alphabetic Characters:");
  Console_Io.Put_Line(S(1..N));
  New_Line;
  T(1..N):=Alphabetical.Pos(S(1..N));
  Put_Line("Their Alphabetical.Pos:");
  Console_Io.Put_Line(T(1..N));
  New_Line;
  Put_Line("Alphabetic Characters Ordered by Alphabetical.Pos:");
  Console_Io.Put_Line(Sort(S,T,N));
end;
begin
  Put_Line("Test of Alphabetical.Pos, with Console_IO:");
  New_Line;
  Verify_Mapping;
  Manual_Test;
end;


